function main()
% in is EEG
% out is MEG
[file1, path1] = uigetfile('*.*', 'Select MEG file');
pathMEG = fullfile(path1, file1);
[file2, path2] = uigetfile('*.*', 'Select EEG file');
pathEEG = fullfile(path2, file2);
outputPath = path2;

% pathMEG = 'd:\\data\temporalregister\\3\\c,rfDC';
% pathEEG = 'd:\\data\temporalregister\\1020_EMG_0003.vhdr';

infosMEG = aw_getfileinfo(pathMEG);
if isempty(infosMEG)
    error('Could not open MEG file');
end
infosEEG = aw_getfileinfo(pathEEG);
if isempty(infosEEG)
   error('Could not open EEG file');
end

cfg=[];
cfg.file = pathEEG;
markersEEG = aw_getmarkers(cfg);
cfg.file = pathMEG;
cfg.extract_triggers = 'yes';
markersMEG = aw_getmarkers(cfg);
disp(markersMEG);

% pas de prise en compte des markers 0 et 512 (front descendant de la voie trigger)
MauvaisMarkers = find([markersMEG(:).value]==0 | [markersMEG(:).value] ==512);
if isempty(MauvaisMarkers) == 0
    markersMEG(MauvaisMarkers)=[];
end

pos_in=1;
pos_target=1;
num_in=length(markersEEG);
num_target=length(markersMEG);
% 
max_search=10;  % max distance for search of corresponding indices
EVT=[]; % matrix of event samples
cnt=1;
% 
%% chercher si le premier event_in correspond a eventss_target(i). Trouver les debut en commun.
%% init
for l = 1: num_in - 1
    val_in = markersEEG(l).value;
    val_in2 = markersEEG(l+1).value;
    val_target=markersMEG(1).value;
    val_target2=markersMEG(2).value;
    if (val_target >= 512)
        val_target = val_target-512+1;
    end
    if (val_target2 >= 512)
        val_target2 = val_target2-512+1;
    end
    if(val_in==val_target && val_in2==val_target2)
        pos_in=l;
        break;  % corresponding event is found, stop search
    end;
end
    

%% loop on TARGET events  to find corresponding IN events

for i=1:num_target % loop on target
    %    in_indices=[max(1,pos_in-max_search):min(num_in,pos_in+max_search)];
    %     in_indices=[max(1,pos_in):min(num_in,pos_in+max_search)];
    in_indices=[max(1,pos_in):min(num_in,pos_in+max_search)];                       %% modif sam car index out of bound
    
    for j=1:length(in_indices)
        val_in = markersEEG(in_indices(j)).value;
        val_target = markersMEG(i).value;
        if(val_in==val_target)
            EVT(cnt,1) = round(markersEEG(in_indices(j)).position * infosEEG.max_sr);
            %EVT(cnt,1)=markersEEG(in_indices(j)).sample;
            %EVT(cnt,2)=markersMEG(i).sample;
            EVT(cnt,2)=round(markersMEG(i).position * infosMEG.max_sr);
            pos_in=in_indices(j)+1;
            %pos_target=pos_target+1;
            cnt=cnt+1;
            break;  % corresponding event is found, stop search
        end;
        if (val_in == mod(val_target,512)+1)
            %EVT(cnt,1)=events_in(in_indices(j)).sample;
            EVT(cnt,1)=round(markersEEG(in_indices(j)).position * infosEEG.max_sr);
            % EVT(cnt,2)=events_target(i).sample;
            EVT(cnt,2)=round(markersMEG(i).position * infosMEG.max_sr);
            pos_in=in_indices(j)+1;
            %pos_target=pos_target+1;
            cnt=cnt+1;
            break;  % corresponding event is found, stop search
        end
    end
end      


%% find mapping from target to in 
[b,bint,r] = regress(EVT(:,1),[ones(size(EVT,1),1) EVT(:,2)]);

Q=quantile(r,[0.25 0.5 0.75]);
thr1=Q(2)-2*(Q(3)-Q(1));
thr2=Q(2)+2*(Q(3)-Q(1));

idx_non_outliers= find(r>=thr1 & r <=thr2);
EVT=EVT(idx_non_outliers,:);

figure;
subplot(2,1,1);
plot(EVT(:,2),EVT(:,1),'+')
hold on
plot(EVT(:,2),[ones(size(EVT,1),1) EVT(:,2)]*b,'r');
xlabel('target samples')
ylabel('infile samples')
title('regression on marker times');
subplot(2,1,2);
hist(r);
title('residuals');
%%% ===== test des nouveaux residus ===== %%%
[b,bint,r] = regress(EVT(:,1),[ones(size(EVT,1),1) EVT(:,2)]);
figure;
hist(r);
title('residuals');
%break; % test if everything's correct
question = questdlg('Does this seem correct ?');
switch question
    case 'Yes'
    case 'No'
        return;
    case 'Cancel'
        return;
end

cfg = [];
cfg.file = pathEEG;
cfg.filtering = 'yes';
cfg.start = 0;
cfg.duration = -1;
cfg.eeg_lp = infosEEG.max_sr / 3;

eegdata = aw_getdata(cfg);
npts_in = length(eegdata(1).data);
nchan_in = numel(eegdata);

npts_target = round(infosMEG.total_duration * infosMEG.max_sr);
samples_target=[1:npts_target]; % all samples from target file
samples_in=b(1)+b(2)*samples_target; % corresponding samples in input file
if(samples_in(1)<1)
    error('the input file starts after target file');
end;
if(samples_in(end)>npts_in)
    error('the input file starts after target file');
end;

%% interpolate into target file time
disp('interpolating...');
data_target=zeros(nchan_in,npts_target);
data_in = zeros(nchan_in,npts_in);
labels={1:nchan_in};
for i=1:nchan_in
    data_in(i,:) = eegdata(i).data;
    labels{i} = eegdata(i).name;
    data_target(i,:)=spline(1:npts_in,eegdata(i).data,samples_in);
end;
disp('done.');

%le fichier EEG sortant prend le nom du fichier EEG d'origine
[infile_path,infile_name,infile_ext] = fileparts(file2) ;
outputFile = fullfile(outputPath,[infile_name '_resample']);
mat2ades(data_target, outputFile, infosMEG.max_sr, labels, 'EEG');

% display sampling in input temporal space
figure;
plot(1:npts_in,ones(npts_in,1),'+');
hold on;
plot(samples_in,ones(length(samples_in),1),'ro')
for i=1:size(EVT,1)
    plot([EVT(i,1) EVT(i,1)],[0 2],'g');
end;
title('sampling in input temporal space')
legend('in samples', 'out samples', 'triggers');
uiwait();

function mat2ades(data,fileName,FS,labels,labelType) 
 
% write in the current folder ADES and DAT files from matrix in MATLAB workspace
% data = matrix of data (nbchannel * time points) - the data have to be in
% microVolt
% fileName = string of the output files without extension ; the ades and
% dat files will have the same name
% FS = sampling rate 
% labels = cell array with channel labels
% labelType : 'EEG' or 'MEG'
% Sophie Chen - January 2014
 
%% generate the ADES file
adesFile = [fileName '.ades'];
 
fid = fopen(adesFile,'wt');
 
fprintf(fid,'%s\r\n','#ADES header file ');
fprintf(fid,'%s','samplingRate = ');
fprintf(fid,'%d\r\n',FS);
fprintf(fid,'%s','numberOfSamples = ');
fprintf(fid,'%d\r\n',size(data,2));
 
for lab = 1:length(labels)
    fprintf(fid,'%s\r\n',[labels{lab} ' = ' labelType]);
end
 
fclose(fid);
 
%% generate the DAT file
 
datFile = [fileName '.dat'];
 
fad = fopen(datFile,'wb');
fwrite(fad, data, 'float32');
fclose(fad);
end
end

